<?php
class ModelCheckoutOrder extends Model {
	public function getOrder($order_id) {
		$query = $this->db->query("SELECT *, c1.iso_code_2 AS shipping_iso_code_2, c1.iso_code_3 AS shipping_iso_code_3, c2.iso_code_2 AS payment_iso_code_2, c2.iso_code_3 AS shipping_iso_code_3, z1.code AS shipping_zone_code, z2.code AS payment_zone_code FROM `" . DB_PREFIX . "order` o LEFT JOIN " . DB_PREFIX . "country c1 ON (o.shipping_country_id = c1.country_id) LEFT JOIN " . DB_PREFIX . "country c2 ON (o.payment_country_id = c2.country_id) LEFT JOIN " . DB_PREFIX . "zone z1 ON (o.payment_zone_id = z1.zone_id) LEFT JOIN " . DB_PREFIX . "zone z2 ON (o.payment_zone_id = z2.zone_id) WHERE o.order_id = '" . (int)$order_id . "'");
	
		return $query->row;
	}	
	
	public function create($data) {
		$query = $this->db->query("SELECT order_id FROM `" . DB_PREFIX . "order` WHERE date_added < '" . date('Y-m-d', strtotime('-1 month')) . "' AND order_status_id = '0'");
		
		foreach ($query->rows as $result) {
			$this->db->query("DELETE FROM `" . DB_PREFIX . "order` WHERE order_id = '" . (int)$result['order_id'] . "'");
      		$this->db->query("DELETE FROM " . DB_PREFIX . "order_history WHERE order_id = '" . (int)$result['order_id'] . "'");
      		$this->db->query("DELETE FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$result['order_id'] . "'");
      		$this->db->query("DELETE FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$result['order_id'] . "'");
	  		$this->db->query("DELETE FROM " . DB_PREFIX . "order_download WHERE order_id = '" . (int)$result['order_id'] . "'");
      		$this->db->query("DELETE FROM " . DB_PREFIX . "order_total WHERE order_id = '" . (int)$result['order_id'] . "'");
		}		
		
		$this->db->query("INSERT INTO `" . DB_PREFIX . "order` SET customer_id = '" . (int)$data['customer_id'] . "', firstname = '" . $this->db->escape($data['firstname']) . "', lastname = '" . $this->db->escape($data['lastname']) . "', email = '" . $this->db->escape($data['email']) . "', telephone = '" . $this->db->escape($data['telephone']) . "', fax = '" . $this->db->escape($data['fax']) . "', total = '" . (float)$data['total'] . "', language_id = '" . (int)$data['language_id'] . "', currency = '" . $this->db->escape($data['currency']) . "', currency_id = '" . (int)$data['currency_id'] . "', value = '" . (float)$data['value'] . "', coupon_id = '" . (int)$data['coupon_id'] . "', ip = '" . $this->db->escape($data['ip']) . "', shipping_firstname = '" . $this->db->escape($data['shipping_firstname']) . "', shipping_lastname = '" . $this->db->escape($data['shipping_lastname']) . "', shipping_company = '" . $this->db->escape($data['shipping_company']) . "', shipping_address_1 = '" . $this->db->escape($data['shipping_address_1']) . "', shipping_address_2 = '" . $this->db->escape($data['shipping_address_2']) . "', shipping_city = '" . $this->db->escape($data['shipping_city']) . "', shipping_postcode = '" . $this->db->escape($data['shipping_postcode']) . "', shipping_zone = '" . $this->db->escape($data['shipping_zone']) . "', shipping_zone_id = '" . (int)$data['shipping_zone_id'] . "', shipping_country = '" . $this->db->escape($data['shipping_country']) . "', shipping_country_id = '" . (int)$data['shipping_country_id'] . "', shipping_address_format = '" . $this->db->escape($data['shipping_address_format']) . "', shipping_method = '" . $this->db->escape($data['shipping_method']) . "', payment_firstname = '" . $this->db->escape($data['payment_firstname']) . "', payment_lastname = '" . $this->db->escape($data['payment_lastname']) . "', payment_company = '" . $this->db->escape($data['payment_company']) . "', payment_address_1 = '" . $this->db->escape($data['payment_address_1']) . "', payment_address_2 = '" . $this->db->escape($data['payment_address_2']) . "', payment_city = '" . $this->db->escape($data['payment_city']) . "', payment_postcode = '" . $this->db->escape($data['payment_postcode']) . "', payment_zone = '" . $this->db->escape($data['payment_zone']) . "', payment_zone_id = '" . (int)$data['payment_zone_id'] . "', payment_country = '" . $this->db->escape($data['payment_country']) . "', payment_country_id = '" . (int)$data['payment_country_id'] . "', payment_address_format = '" . $this->db->escape($data['payment_address_format']) . "', payment_method = '" . $this->db->escape($data['payment_method']) . "', comment = '" . $this->db->escape($data['comment']) . "', date_modified = NOW(), date_added = NOW()");

		$order_id = $this->db->getLastId();

		foreach ($data['products'] as $product) { 
			$this->db->query("INSERT INTO " . DB_PREFIX . "order_product SET order_id = '" . (int)$order_id . "', product_id = '" . (int)$product['product_id'] . "', name = '" . $this->db->escape($product['name']) . "', model = '" . $this->db->escape($product['model']) . "', price = '" . (float)$product['price'] . "', total = '" . (float)$product['total'] . "', tax = '" . (float)$product['tax'] . "', quantity = '" . (int)$product['quantity'] . "'");
 
			$order_product_id = $this->db->getLastId();

			foreach ($product['option'] as $option) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "order_option SET order_id = '" . (int)$order_id . "', order_product_id = '" . (int)$order_product_id . "', product_option_value_id = '" . (int)$option['product_option_value_id'] . "', name = '" . $this->db->escape($option['name']) . "', `value` = '" . $this->db->escape($option['value']) . "', price = '" . (float)$product['price'] . "', prefix = '" . $this->db->escape($option['prefix']) . "'");
			}
				
			foreach ($product['download'] as $download) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "order_download SET order_id = '" . (int)$order_id . "', order_product_id = '" . (int)$order_product_id . "', name = '" . $this->db->escape($download['name']) . "', filename = '" . $this->db->escape($download['filename']) . "', mask = '" . $this->db->escape($download['mask']) . "', remaining = '" . (int)($download['remaining'] * $product['quantity']) . "'");
			}	
		}
		
		foreach ($data['totals'] as $total) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "order_total SET order_id = '" . (int)$order_id . "', title = '" . $this->db->escape($total['title']) . "', text = '" . $this->db->escape($total['text']) . "', `value` = '" . (float)$total['value'] . "', sort_order = '" . (int)$total['sort_order'] . "'");
		}	

		return $order_id;
	}

	public function confirm($order_id, $order_status_id, $comment = '') {
		$order_query = $this->db->query("SELECT *, l.code AS language FROM `" . DB_PREFIX . "order` o LEFT JOIN " . DB_PREFIX . "language l ON (o.language_id = l.language_id) WHERE o.order_id = '" . (int)$order_id . "' AND o.order_status_id = '0'");
		 
		if ($order_query->num_rows) {
			$this->db->query("UPDATE `" . DB_PREFIX . "order` SET order_status_id = '" . (int)$order_status_id . "' WHERE order_id = '" . (int)$order_id . "'");

			$this->db->query("INSERT INTO " . DB_PREFIX . "order_history SET order_id = '" . (int)$order_id . "', order_status_id = '" . (int)$order_status_id . "', notify = '1', comment = '" . $this->db->escape($comment) . "', date_added = NOW()");
			
			$language = new Language($order_query->row['language']);
			$language->load('checkout/confirm');
			
			$this->load->model('localisation/currency');
			
			$subject = sprintf($language->get('mail_new_order_subject'), html_entity_decode($this->config->get('config_store'), ENT_QUOTES, 'UTF-8'), $order_id );
			$order_status_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_status WHERE order_status_id = '" . (int)$order_status_id . "' AND language_id = '" . (int)$order_query->row['language_id'] . "'");
			$order_product_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$order_id . "'");
			$order_total_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_total WHERE order_id = '" . (int)$order_id . "' ORDER BY sort_order ASC");
			$order_download_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_download WHERE order_id = '" . (int)$order_id . "'");
			
			// Text Mail
			$message  = sprintf($language->get('mail_new_order_greeting'), html_entity_decode($this->config->get('config_store'), ENT_QUOTES, 'UTF-8')) . "\n\n";
			$message .= $language->get('mail_new_order_order') . ' ' . $order_id . "\n";
			$message .= $language->get('mail_new_order_date_added') . ' ' . date($language->get('date_format_short'), strtotime($order_query->row['date_added'])) . "\n";
			$message .= $language->get('mail_new_order_order_status') . ' ' . $order_status_query->row['name'] . "\n\n";
			$message .= $language->get('mail_new_order_product') . "\n";
			
			//Q: Add more detail to email
			$subject = '';
			$message .= '-----------------------------------------------' . "\n";
			$message .= html_entity_decode($language->get('mail_new_order_payment_address'), ENT_NOQUOTES, 'UTF-8') . "\n";
			if ($order_query->row['payment_company'] != '') {$message .= html_entity_decode($order_query->row['payment_company'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['payment_firstname'] != '') {$message .= html_entity_decode($order_query->row['payment_firstname'], ENT_NOQUOTES, 'UTF-8') ;}
			if ($order_query->row['payment_lastname'] != '') {$message .= ' ' . html_entity_decode($order_query->row['payment_lastname'] , ENT_NOQUOTES, 'UTF-8') . "\n";} else { $message .= "\n"; }
			if ($order_query->row['payment_address_1'] != '') {$message .= html_entity_decode($order_query->row['payment_address_1'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
			if ($order_query->row['payment_address_2'] != '') {$message .= html_entity_decode($order_query->row['payment_address_2'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['payment_city'] != '') {$message .= html_entity_decode($order_query->row['payment_city'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
			if ($order_query->row['payment_postcode'] != '') {$message .= html_entity_decode($order_query->row['payment_postcode'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
			if ($order_query->row['payment_zone'] != '') {$message .= html_entity_decode($order_query->row['payment_zone'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['payment_country'] != '') {$message .= html_entity_decode($order_query->row['payment_country'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['email'] != '') {$message .= html_entity_decode($order_query->row['email'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['telephone'] != '') {$message .= html_entity_decode($order_query->row['telephone'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
			if ($order_query->row['ip'] != '') {$message .= html_entity_decode($order_query->row['ip'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			
			if ($order_query->row['shipping_method'] != '') {$message .= "\n" . html_entity_decode($language->get('mail_new_order_shipping_address'), ENT_NOQUOTES, 'UTF-8')  . "\n";
			if ($order_query->row['shipping_company'] != '') {$message .= html_entity_decode($order_query->row['shipping_company'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['shipping_firstname'] != '') {$message .= html_entity_decode($order_query->row['shipping_firstname'], ENT_NOQUOTES, 'UTF-8') ;}
			if ($order_query->row['shipping_lastname'] != '') {$message .= ' ' . html_entity_decode($order_query->row['shipping_lastname'] , ENT_NOQUOTES, 'UTF-8') . "\n";} else { $message .= "\n"; }
			if ($order_query->row['shipping_address_1'] != '') {$message .= html_entity_decode($order_query->row['shipping_address_1'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['shipping_address_2'] != '') {$message .= html_entity_decode($order_query->row['shipping_address_2'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
			if ($order_query->row['shipping_city'] != '') {$message .= html_entity_decode($order_query->row['shipping_city'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['shipping_postcode'] != '') {$message .= html_entity_decode($order_query->row['shipping_postcode'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
			if ($order_query->row['shipping_zone'] != '') {$message .= html_entity_decode($order_query->row['shipping_zone'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
			if ($order_query->row['shipping_country'] != '') {$message .= html_entity_decode($order_query->row['shipping_country'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
			}
			$message .= '-----------------------------------------------' . "\n";
			
			$message .= $language->get('mail_new_order_payment_method') . "\n";
			$message .= $order_query->row['payment_method'] . "\n\n";
			
			if($order_query->row['shipping_method'] != '') {
				$message .= $language->get('mail_new_order_shipping_method') . "\n";
				$message .= $order_query->row['shipping_method'] . "\n\n";
			}
			//
			
			foreach ($order_product_query->rows as $result) {
				$message .= $result['quantity'] . 'x ' . $result['name'] . ' (' . $result['model'] . ') ' . $this->currency->format($result['total'], $order_query->row['currency'], $order_query->row['value']) . "\n";
				$order_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$order_id . "' AND order_product_id = '" . $result['order_product_id'] . "'");
				foreach ($order_option_query->rows as $option) {//Q: EOE
					$message .= chr(9) . '-' . $option['name'] . ' ' . $option['value'] . "\n";
				}
			}
			
			$message .= "\n";
			
			$message .= $language->get('mail_new_order_total') . "\n";
			
			foreach ($order_total_query->rows as $result) {
				$message .= $result['title'] . ' ' . html_entity_decode($result['text'], ENT_NOQUOTES, 'UTF-8') . "\n";
			}
			
			//Q:EOE
			$subject =  sprintf($language->get('mail_new_order_subject'), $this->config->get('config_store'), $order_id . ' (' . html_entity_decode($result['text'], ENT_NOQUOTES, 'UTF-8') . ')');
			
			$message .= "\n";
			
			$message .= $language->get('mail_new_order_invoice') . "\n";
			$message .= html_entity_decode($this->url->http('account/invoice&order_id=' . $order_id), ENT_QUOTES, 'UTF-8') . "\n\n";
			
			if ($order_download_query->num_rows) {
				$message .= $language->get('mail_new_order_download') . "\n";
				$message .= $this->url->http('account/download') . "\n\n";
			}
			
			//Q: get original order comments
			if ($order_query->row['comment'] != '') {
				$comment = ($order_query->row['comment'] .  "\n\n" . $comment);
			}
			
			if ($comment) {
				$message .= $language->get('mail_new_order_comment') . "\n\n";
				$message .= $comment . "\n\n";
			}
			
			$message .= $language->get('mail_new_order_footer');

			$mail = new Mail($this->config->get('config_mail_protocol'), $this->config->get('config_smtp_host'), $this->config->get('config_smtp_username'), html_entity_decode($this->config->get('config_smtp_password'), ENT_QUOTES, 'UTF-8'), $this->config->get('config_smtp_port'), $this->config->get('config_smtp_timeout')); 
			$mail->setTo($order_query->row['email']);
			$mail->setFrom($this->config->get('config_email'));
			$mail->setSender(html_entity_decode($this->config->get('config_store'), ENT_QUOTES, 'UTF-8'));
			$mail->setSubject($subject);
			$mail->setText($message);
			$mail->send();
			
			if ($this->config->get('config_alert_mail')) {
				$message  = $language->get('mail_new_order_received') . "\n\n";
				$message .= $language->get('mail_new_order_order') . ' ' . $order_id . "\n";
				$message .= $language->get('mail_new_order_date_added') . ' ' . date($language->get('date_format_short'), strtotime($order_query->row['date_added'])) . "\n";
				$message .= $language->get('mail_new_order_order_status') . ' ' . $order_status_query->row['name'] . "\n\n";
				$message .= $language->get('mail_new_order_product') . "\n";
				
				//Q: Add more detail to email
				$message .= '-----------------------------------------------' . "\n";
				$message .= html_entity_decode($language->get('mail_new_order_payment_address'), ENT_NOQUOTES, 'UTF-8') . "\n";
				if ($order_query->row['payment_company'] != '') {$message .= html_entity_decode($order_query->row['payment_company'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				if ($order_query->row['payment_firstname'] != '') {$message .= html_entity_decode($order_query->row['payment_firstname'], ENT_NOQUOTES, 'UTF-8') ;}
				if ($order_query->row['payment_lastname'] != '') {$message .= ' ' . html_entity_decode($order_query->row['payment_lastname'], ENT_NOQUOTES, 'UTF-8')  . "\n";} else { $message .= "\n"; }
				if ($order_query->row['payment_address_1'] != '') {$message .= html_entity_decode($order_query->row['payment_address_1'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				if ($order_query->row['payment_address_2'] != '') {$message .= html_entity_decode($order_query->row['payment_address_2'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				if ($order_query->row['payment_city'] != '') {$message .= html_entity_decode($order_query->row['payment_city'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				if ($order_query->row['payment_postcode'] != '') {$message .= html_entity_decode($order_query->row['payment_postcode'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				if ($order_query->row['payment_zone'] != '') {$message .= html_entity_decode($order_query->row['payment_zone'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				if ($order_query->row['payment_country'] != '') {$message .= html_entity_decode($order_query->row['payment_country'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				if ($order_query->row['email'] != '') {$message .= html_entity_decode($order_query->row['email'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
				if ($order_query->row['telephone'] != '') {$message .= html_entity_decode($order_query->row['telephone'] , ENT_NOQUOTES, 'UTF-8') . "\n";}
				if ($order_query->row['ip'] != '') {$message .= html_entity_decode($order_query->row['ip'], ENT_NOQUOTES, 'UTF-8')  . "\n";}
				
				if ($order_query->row['shipping_method'] != '') {$message .= "\n" . html_entity_decode($language->get('mail_new_order_shipping_address'), ENT_NOQUOTES, 'UTF-8') . "\n";
				if ($order_query->row['shipping_company'] != '') {$message .= html_entity_decode($order_query->row['shipping_company'] , ENT_NOQUOTES, 'UTF-8'). "\n";}
				if ($order_query->row['shipping_firstname'] != '') {$message .= html_entity_decode($order_query->row['shipping_firstname'], ENT_NOQUOTES, 'UTF-8');}
				if ($order_query->row['shipping_lastname'] != '') {$message .= ' ' . html_entity_decode($order_query->row['shipping_lastname'] , ENT_NOQUOTES, 'UTF-8') . "\n";} else { $message .= "\n"; }
				if ($order_query->row['shipping_address_1'] != '') {$message .= html_entity_decode($order_query->row['shipping_address_1'], ENT_NOQUOTES, 'UTF-8') . "\n";}
				if ($order_query->row['shipping_address_2'] != '') {$message .= html_entity_decode($order_query->row['shipping_address_2'], ENT_NOQUOTES, 'UTF-8') . "\n";}
				if ($order_query->row['shipping_city'] != '') {$message .= html_entity_decode($order_query->row['shipping_city'], ENT_NOQUOTES, 'UTF-8') . "\n";}
				if ($order_query->row['shipping_postcode'] != '') {$message .= html_entity_decode($order_query->row['shipping_postcode'], ENT_NOQUOTES, 'UTF-8') . "\n";}
				if ($order_query->row['shipping_zone'] != '') {$message .= html_entity_decode($order_query->row['shipping_zone'], ENT_NOQUOTES, 'UTF-8') . "\n";}
				if ($order_query->row['shipping_country'] != '') {$message .= html_entity_decode($order_query->row['shipping_country'] , ENT_NOQUOTES, 'UTF-8'). "\n";}
				}
				$message .= '-----------------------------------------------' . "\n";
				
				$message .= $language->get('mail_new_order_payment_method') . "\n";
				$message .= $order_query->row['payment_method'] . "\n\n";
				
				if($order_query->row['shipping_method'] != '') {
					$message .= $language->get('mail_new_order_shipping_method') . "\n";
					$message .= $order_query->row['shipping_method'] . "\n\n";
				}				
				//
				
				foreach ($order_product_query->rows as $result) {
					$message .= $result['quantity'] . 'x ' . $result['name'] . ' (' . $result['model'] . ') ' . $this->currency->format($result['total'], $order_query->row['currency'], $order_query->row['value']) . "\n";
					$order_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$order_id . "' AND order_product_id = '" . $result['order_product_id'] . "'");
					foreach ($order_option_query->rows as $option) {//Q: EOE
						$message .= chr(9) . '-' . $option['name'] . ' ' . $option['value'] . "\n";
					}
				}
				
				$message .= "\n";

				$message .= $language->get('mail_new_order_total') . "\n";
				
				foreach ($order_total_query->rows as $result) {
					$message .= $result['title'] . ' ' . html_entity_decode($result['text'], ENT_NOQUOTES, 'UTF-8') . "\n";
				}			
				
				$message .= "\n";
				
				if ($order_download_query->num_rows) {
					$message .= $language->get('mail_new_order_download') . "\n";
					$message .= $this->url->http('account/download') . "\n\n";
				}
				
				if ($comment) {
					$message .= $language->get('mail_new_order_comment') . "\n\n";
					$message .= $comment . "\n\n";
				}
			
				$mail = new Mail($this->config->get('config_mail_protocol'), $this->config->get('config_smtp_host'), $this->config->get('config_smtp_username'), $this->config->get('config_smtp_password'), $this->config->get('config_smtp_port'), $this->config->get('config_smtp_timeout')); 
				$mail->setTo($this->config->get('config_email'));
				$mail->setFrom($this->config->get('config_email'));
				$mail->setSender(html_entity_decode($this->config->get('config_store'), ENT_QUOTES, 'UTF-8'));
				$mail->setSubject($subject);
				$mail->setText($message);
				$mail->send();				
			}
			
			if ($this->config->get('config_stock_subtract')) {
				$order_product_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$order_id . "'");
			
				foreach ($order_product_query->rows as $product) {
					$this->db->query("UPDATE " . DB_PREFIX . "product SET quantity = (quantity - " . (int)$product['quantity'] . ") WHERE product_id = '" . (int)$product['product_id'] . "'");
				
					$order_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$order_id . "' AND order_product_id = '" . (int)$product['order_product_id'] . "'");
				
					foreach ($order_option_query->rows as $option) {
						$this->db->query("UPDATE " . DB_PREFIX . "product_option_value SET quantity = (quantity - " . (int)$product['quantity'] . ") WHERE product_option_value_id = '" . (int)$option['product_option_value_id'] . "' AND subtract = '1'");
					}
				}
			}			
		}
	}
	
	public function update($order_id, $order_status_id, $comment = '', $notifiy = FALSE) {
		$order_query = $this->db->query("SELECT *, o.language_id, l.code AS language FROM `" . DB_PREFIX . "order` o LEFT JOIN " . DB_PREFIX . "language l ON (o.language_id = l.language_id) WHERE o.order_id = '" . (int)$order_id . "' AND o.order_status_id > '0'");
		
		if ($order_query->num_rows) {
			$this->db->query("UPDATE `" . DB_PREFIX . "order` SET order_status_id = '" . (int)$order_status_id . "', date_modified = NOW() WHERE order_id = '" . (int)$order_id . "'");
		
			$this->db->query("INSERT INTO " . DB_PREFIX . "order_history SET order_id = '" . (int)$order_id . "', order_status_id = '" . (int)$order_status_id . "', notify = '" . (int)$notifiy . "', comment = '" . $this->db->escape($comment) . "', date_added = NOW()");
	
			if ($notifiy) {
				$language = new Language($order_query->row['language']);
				$language->load('checkout/confirm');
	
				$subject = sprintf($language->get('mail_update_order_subject'), html_entity_decode($this->config->get('config_store'), ENT_QUOTES, 'UTF-8'), $order_id);
	
				$message  = $language->get('mail_update_order_order') . ' ' . $order_id . "\n";
				$message .= $language->get('mail_update_order_date_added') . ' ' . date($language->get('date_format_short'), strtotime($order_query->row['date_added'])) . "\n\n";
				$message .= $language->get('mail_update_order_order_status') . "\n\n";
				
				$order_status_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_status WHERE order_status_id = '" . (int)$order_status_id . "' AND language_id = '" . (int)$order_query->row['language_id'] . "'");
				
				$message .= $order_status_query->row['name'] . "\n\n";
					
				$message .= $language->get('mail_update_order_invoice') . "\n";
				$message .= html_entity_decode($this->url->http('account/invoice&order_id=' . $order_id), ENT_QUOTES, 'UTF-8') . "\n\n";
					
				if ($comment) { 
					$message .= $language->get('mail_update_order_comment') . "\n\n";
					$message .= $comment . "\n\n";
				}
					
				$message .= $language->get('mail_update_order_footer');

				$mail = new Mail($this->config->get('config_mail_protocol'), $this->config->get('config_smtp_host'), $this->config->get('config_smtp_username'), html_entity_decode($this->config->get('config_smtp_password'), ENT_QUOTES, 'UTF-8'), $this->config->get('config_smtp_port'), $this->config->get('config_smtp_timeout'));
				$mail->setTo($order_query->row['email']);
				$mail->setFrom($this->config->get('config_email'));
				$mail->setSender(html_entity_decode($this->config->get('config_store'), ENT_QUOTES, 'UTF-8'));
				$mail->setSubject($subject);
				$mail->setText($message);
				$mail->send();
			}
		}
	}
}
?>